
# Dapr 1.9.0

We're happy to announce the release of Dapr 1.9.0!

We would like to extend our thanks to all the new and existing contributors who helped make this release happen.

## Acknowledgements

Thanks to everyone who made this release possible!

@1046102779, @117503445, @AaronCrawfis, @Abirdcfly, @addjuarez, @ahmedhesham6, @akhilac1, @akkie, @amulyavarote, @anoymouscoder, @artursouza, @bbrandt, @beiwei30, @benc-uk, @berndverst, @bibryam, @blublinsky, @c-thiel, @CeresCa, @cgillum, @christle, @clareliguori, @cmendible, @codefromthecrypt, @CrazyHZM, @daixiang0, @DeepanshuA, @DiegoAJR, @dss539, @dwhiteddsoft, @famarting, @fjvela, @gabrielemilan, @gautric, @greenie-msft, @halspang, @helbing, @hhunter-ms, @hueifeng, @hunter007, @hypernova3, @imneov, @ItalyPaleAle, @jaczhao, @jigargandhi, @jilichao, @jinjianfeng-chn, @jjcollinge, @johnewart, @juazasan, @kumaya, @l0ll098, @Lichmaker, @mandarj123, @marioreggiori, @martin-bucinskas, @mcandeia, @mikeb26, @mindovermiles262, @msfussell, @mthmulders, @mukundansundar, @my-petrichor, @NickLarsenNZ, @nyemade-uversky, @ostreek, @piotrkpc, @pravinpushkar, @qiangmzsx, @qqbuby, @rabollin, @RcXu, @rogerogers, @RyanLettieri, @saber-wang, @sarsharma, @shivamkm07, @shivanisinghnitp, @shubham1172, @sk593, @skyao, @sunzhaochang, @Taction, @tanvigour, @thisiskun, @tmacam, @Trolldemorted, @webup, @Willmish, @winterfoxnet, @x-shadow-man, @XavierGeerinck, @xingrux, @yaron2, @yash-nisar, @zcong1993

## Highlights

### Pluggable components

Dapr has built-in components that are included as part of the runtime. Dapr now allows you to create private components called ["pluggable components"](https://v1-9.docs.dapr.io/operations/components/pluggable-components). These are components that are self-hosted (exe or container), can be written in any language that supports gRPC, exist outside the Dapr runtime, and are able to "plug" into Dapr. Simply write a component with a gRPC service, drop a binary into the filesystem and you're good to go. Works for both Kubernetes and self-hosted modes.<br>

### Observability: Open Telemetry (OTEL) protocol support 

OpenTelemetry (OTEL) combines projects like OpenCensus, Zipkin, and OpenTracing into standard API and specification sets for tracing and metrics. In this release, Dapr includes [support for the OpenTelemetry protocol](https://v1-9.docs.dapr.io/developing-applications/building-blocks/observability/w3c-tracing-overview/), which is the preferred way to send traces to observability tools.

### Observability: Resiliency metrics
Metrics have been added for [resiliency](https://github.com/dapr/dapr/blob/master/docs/development/dapr-metrics.md#resiliency). The number of resiliency policies loaded and the number of times a resiliency policy has been executed.

[Learn about OpenTelemetry](https://v1-9.docs.dapr.io/concepts/observability-concept/#distributed-tracing) on Dapr sidecars to write traces for your applications to any monitoring service that supports the OTEL protocol.

### Reliability: Application health checks
App health checks are a new feature that allows probing for the health of your application and reacting to status changes. Applications can become unresponsive for a variety of reasons: for example, they could be too busy to accept new work, or could be crashed or in a deadlock state. Sometimes the condition can be transient, for example if the app is just busy or if the application is being restarted for whatever reason and is in its initialization phase.

When app health checks are enabled, the Dapr runtime will periodically poll your application via HTTP or gRPC calls. When it detects a failure in the app's health, Dapr stops accepting new work on behalf of the application. 

[Learn about app health checks](https://v1-9.docs.dapr.io/operations/observability/app-health)

### Reliability: Default resiliency policies
With resiliency policies you can now set **default policies**, which can have a broad scope. This is done through reserved keywords that apply to given policy. There are 3 default policies types: 

- DefaultRetryPolicy
- DefaultTimeoutPolicy
- DefaultCircuitBreakerPolicy

If these policies are defined, they are used for every operation to a service, application, or component. They can also be modified to be more specific through the usage of additional keywords for specific targets.

[Learn about default resiliency policies](https://v1-9.docs.dapr.io/operations/resiliency/policies/#setting-default-policies)

### Service-Invocation: Application middleware 
You can now use any middleware components when making service-to-service invocation calls. For example, for token validation in a zero-trust environment or to apply OAuth policies. Service-to-service invocation middleware components apply to all outgoing calls from Dapr sidecar to the receiving application. 

[Learn more about app middleware](https://v1-9.docs.dapr.io/developing-applications/middleware/#configuring-app-middleware-pipelines)

### Pub/Sub: Namespaced consumer groups

Drive infrastructure efficiency with namespaced consumer groups for pub/sub. This feature allows you to deploy Dapr applications to different namespaces who all share the same app id, and have all topic subscriptions scoped at the namespace level. This allows development teams to reuse the same pub/sub underlying infrastructure without needing to change their code based on the namespace they are running in.

Learn about [namespaced consumer groups](https://v1-9.docs.dapr.io/developing-applications/building-blocks/pubsub/howto-namespace/).

### CLI and Installers

#### Windows MSI installer
Now there's a new way to consume the Dapr CLI on Windows: [Install the CLI using the MSI installer](https://v1-9.docs.dapr.io/getting-started/install-dapr-cli/#install-using-msi-installer).

#### Podman container runtime support
You can now use [podman container runtime](https://v1-9.docs.dapr.io/operations/hosting/self-hosted/self-hosted-with-podman/) (as an alternative to the Docker runtime) for your local development.

Learn about a [pluggable components]((https://docs.dapr.io/operations/components/pluggable-components)).

### Security: Component deny lists
You can now specify a [components.deny](https://v1-9.docs.dapr.io/operations/configuration/configuration-overview/#disallow-usage-of-certain-component-types) property in the Configuration spec to specify a denylist of component types that cannot be initialized. This prevents Dapr from using excluded components during initialization.

### Component updates

#### Multi-Key value secret stores
[Secret stores](https://v1-9.docs.dapr.io/reference/components-reference/supported-secret-stores/) now support the ability to return multiple keys and secret values with a single call. For example [Hashicorp Vault](https://v1-9.docs.dapr.io/reference/components-reference/supported-secret-stores/hashicorp-vault/#multiple-key-values-per-secret) and [Local File](https://v1-9.docs.dapr.io/reference/components-reference/supported-secret-stores/file-secret-store/#multiple-key-values-behavior) secret stores. This makes it easier for an application to retrieve multiple keys at once.

#### Component stabilization

In this release, the following component improvements were designated as [stable](https://docs.dapr.io/operations/components/certification-lifecycle/#stable): 

##### State management

- Memcached
- Azure Table Storage
- Apache Cassandra

##### Bindings

- RabbitMQ
- Local Storage
- Postgres

##### Secrets management

- Local File
- Local ENV Variable

#### New components

There are now 105 built-in components in Dapr. Three new components were added in this release:

- [Azure App configuration store](https://v1-9.docs.dapr.io/reference/components-reference/supported-configuration-stores/azure-appconfig-configuration-store/)
- [Postgres configuration store](https://v1-9.docs.dapr.io/reference/components-reference/supported-configuration-stores/postgres-configuration-store/)
- [Alibaba Cloud Simple Log Storage (SLS) output binding](https://v1-9.docs.dapr.io/reference/components-reference/supported-bindings/alicloudsls/)

### Next steps

If you're new to Dapr, visit the [getting started](https://docs.dapr.io/getting-started/) page and familiarize yourself with Dapr.

Docs have been updated with all the new features and changes of this release. To get started with new capabilities introduced in this release, go to the [Concepts](https://docs.dapr.io/concepts/) and the [Developing applications](https://docs.dapr.io/developing-applications/).

> **Note: This release contains [breaking changes](#breaking-changes) in the runtime and SDKs.**

See [this](#upgrading-to-dapr-1.9.0) section on upgrading Dapr to version 1.9.0.

## New in this release

### Dapr Runtime
- **ADDED** Trace export using OpenTelemetry protocol [2836](https://github.com/dapr/dapr/issues/2836)
- **ADDED** Deprecation notice of Actor Reminder's Rename API [4445](https://github.com/dapr/dapr/issues/4445)
- **FIXED** Bug in runtime. HTTP Pipeline invocation executes as designed [4475](https://github.com/dapr/dapr/issues/4475)
- **ADDED** Metrics for Resiliency [4524](https://github.com/dapr/dapr/issues/4524)
- **FIXED** Postgres support for Configuration API [4551](https://github.com/dapr/dapr/issues/4551)
- **CHANGED** Converting configuration API response from an array to dictionary. [4556](https://github.com/dapr/dapr/issues/4556)
- **FIXED** Remove state store entries for unregistered timers [4801](https://github.com/dapr/dapr/issues/4801)
- **FIXED** Dapr service still exists after the deployment deleted [4849](https://github.com/dapr/dapr/issues/4849)
- **ADDED** Kubernetes namespace isolation option for Dapr PubSub [4872](https://github.com/dapr/dapr/issues/4872)
- **ADDED** App health checks: pause bindings and pubsub components when app is not healthy [4883](https://github.com/dapr/dapr/issues/4883)
- **FIXED** Incorrect log messages [4885](https://github.com/dapr/dapr/pull/4885) [4901](https://github.com/dapr/dapr/pull/4901)
- **FIXED** gRPC proxy recreates connection on every request [4937](https://github.com/dapr/dapr/issues/4937)
- **ADDED** Component denylist via Configuration CRD [4946](https://github.com/dapr/dapr/pull/4946)
- **FIXED** Metric for mtlsWorkloadCertRotated [4951](https://github.com/dapr/dapr/pull/4951)
- **FIXED** Building a new component that uses GRPC protocol crashes due to codec being globally applied [4959](https://github.com/dapr/dapr/issues/4959)
- **FIXED** Error thrown while using HTTP Configuration Subscribe API  [4968](https://github.com/dapr/dapr/issues/4968)
- **ADDED** Dead letter topics to Subscription CRD [4978](https://github.com/dapr/dapr/issues/4978)
- **ADDED** Otel section to Configuration CRD [4980](https://github.com/dapr/dapr/issues/4980)
- **ADDED** Add output-binding component alicloud.sls support logic [4983](https://github.com/dapr/dapr/issues/4983)
- **RENAMED** Distributed Lock API UnlockResponse.Status [4988](https://github.com/dapr/dapr/issues/4988)
- **ADDED** New parameter to daprd binary: `resources-path` [4998](https://github.com/dapr/dapr/pull/4998)
- **ADDED** Missing endpoints for API allowlist [5007](https://github.com/dapr/dapr/issues/5007)
- **FIXED** HTTP Unsubscribe response to return a response body [5017](https://github.com/dapr/dapr/issues/5017)
- **ADDED** Active Actors count in gRPC metadata API [5018](https://github.com/dapr/dapr/pull/5018)
- **ADDED** Recommended labels to Dapr control plane Kubernetes objects [5029](https://github.com/dapr/dapr/issues/5029)
- **ADDED** Support Lock component aliasing [5030](https://github.com/dapr/dapr/issues/5030)
- **ADDED** Missing `registered_components` in GRPC Metadata API [5051](https://github.com/dapr/dapr/issues/5051)
- **FIXED** gRPC Service Invocation to emit metrics [5073](https://github.com/dapr/dapr/issues/5073)
- **ADDED** State Store Pluggable Components [5102](https://github.com/dapr/dapr/pull/5102)
- **ADDED** Metric for service updates [5114](https://github.com/dapr/dapr/pull/5114)
- **ADDED** New `time` attribute to CloudEvent automatically if not present [5137](https://github.com/dapr/dapr/issues/5137)
- **FIXED** Bug where components would not be loaded on operator restart [5142](https://github.com/dapr/dapr/issues/5142)
- **ADDED** Kubernetes support for Pluggable Components [5151](https://github.com/dapr/dapr/pull/5151)
- **REMOVED** `application/json` as default content type for service invocation [5165](https://github.com/dapr/dapr/issues/5165)
- **FIXED** gRPC span status on error [5166](https://github.com/dapr/dapr/pull/5166)
- **ADDED** Wait of 30s for Dapr api to be ready to establish connection from dapr runtime. [5168](https://github.com/dapr/dapr/pull/5168)
- **ADDED** PubSub Pluggable Component [5173](https://github.com/dapr/dapr/issues/5173) [5175](https://github.com/dapr/dapr/pull/5175)
- **FIXED** Dapr input binding request fails when returning status code 204 in an input binding handler. [5180](https://github.com/dapr/dapr/issues/5180)
- **ADDED** Metadata to InvokeActorRequest. [5191](https://github.com/dapr/dapr/issues/5191)
- **ADDED** Protos for Bindings Pluggable Components [5194](https://github.com/dapr/dapr/issues/5194)
- **ADDED** PubSub and SecretStore capabilities/features to the Metadata API results. [5211](https://github.com/dapr/dapr/issues/5211)
- **ADDED** Metadata to invokeActorReq [5215](https://github.com/dapr/dapr/pull/5215)
- **FIXED** Configuration Building Block where Http Subscribe AlphaV1 API would need the app to be in ready status. [5236](https://github.com/dapr/dapr/issues/5236)
- **ADDED** Pluggable Components Discovery [5261](https://github.com/dapr/dapr/issues/5261)
- **ADDED** Option to Helm chart to skip deploying Dapr dashboard [5263](https://github.com/dapr/dapr/pull/5263)
- **FIXED** Sidecar watchdog waits for the Dapr injector to be ready before running  [5287](https://github.com/dapr/dapr/pull/5287)
- **FIXED** Multiple data race conditions [5143](https://github.com/dapr/dapr/pull/5143) [5289](https://github.com/dapr/dapr/issues/5289)
- **FIXED** Processing messages on ASB binding causes sidecar to crash in some situations [5304](https://github.com/dapr/dapr/issues/5304)

### Dapr CLI

- **FIXED** `dapr list` does not include independent `daprd` instances [220](https://github.com/dapr/cli/issues/220)
- **ADDED** Support for podman as container runtime [257](https://github.com/dapr/cli/issues/257)
- **ADDED** Dapr installer to winget [424](https://github.com/dapr/cli/issues/424)
- **FIXED** Dashboard to no longer be part of HA mode logic [817](https://github.com/dapr/cli/pull/817)
- **ADDED** Support for custom metadata in `dapr publish` using the new `--metadata` flag. [842](https://github.com/dapr/cli/issues/842)
- **ADDED** Support for dashboard port automatic selection. [863](https://github.com/dapr/cli/issues/863)
- **ADDED** support for multiple kubeconfig files [884](https://github.com/dapr/cli/issues/884)
- **ADDED** Support for private helm chart repo to install dapr cluster [895](https://github.com/dapr/cli/pull/895)
- **FIXED** Differing behavior of `dapr uninstall -k` and `dapr uninstall` when `dapr` not installed  [952](https://github.com/dapr/cli/issues/952)
- **ADDED** Support for SystemDrive environment variable in Dapr install script for Windows [989](https://github.com/dapr/cli/pull/989)
- **ADDED** Support for using Mariner-based images [1004](https://github.com/dapr/cli/issues/1004)
- **ADDED** `dapr-internal-grpc-port` to `dapr run` options to set internal gRPC server port [1026](https://github.com/dapr/cli/issues/1026)
- **CHANGED** Removing the use of the ioutil package [1037](https://github.com/dapr/cli/pull/1037)
- **FIXED** `dapr init` issue in an environment where proxy is needed. [1043](https://github.com/dapr/cli/issues/1043)
- **FIXED** Fixed redis version to redis 6 on `dapr init` [1045](https://github.com/dapr/cli/pull/1045)
- **ADDED** Support for Windows MSI Installer for CLI [1064](https://github.com/dapr/cli/issues/1064)
- **ADDED** App health check flags for `dapr run` [1082](https://github.com/dapr/cli/issues/1082)

### Components

- **CHANGED** Configuration API response now a dictionary instead of array. [1770](https://github.com/dapr/components-contrib/issues/1770)
- **FIXED** AWS SQS/SNS submit more than 20 statement in access policy [1780](https://github.com/dapr/components-contrib/issues/1780)
- **CHANGED** refactored aws sqs policy inserting [1807](https://github.com/dapr/components-contrib/pull/1807)
- **FIXED** RocketMQ fix metadata properties [1817](https://github.com/dapr/components-contrib/pull/1817)
- **ADDED** middleware: changes wasm basic to use waPC [1833](https://github.com/dapr/components-contrib/pull/1833)
- **ADDED** Support for Azure AD auth in Azure Storage queues and SignalR bindings [1842](https://github.com/dapr/components-contrib/pull/1842) [1852](https://github.com/dapr/components-contrib/pull/1852)
- **ADDED** Kafka: SASL SCRAM SHA-256 and SHA-512 Authentication [1856](https://github.com/dapr/components-contrib/pull/1856)
- **FIXED** issue where Azure Service Bus binding would not receive messages after some time. [1865](https://github.com/dapr/components-contrib/issues/1865)
- **FIXED** SendGrid output binding content error. [1866](https://github.com/dapr/components-contrib/issues/1866)
- **ADDED** New binding: Alicloud SLS log storage [1873](https://github.com/dapr/components-contrib/pull/1873)
- **ADDED** Azure AppConfig configuration store [1874](https://github.com/dapr/components-contrib/pull/1874)
- **ADDED** pubsub.mqtt: support wildcard and shared subscriptions [1882](https://github.com/dapr/components-contrib/pull/1882) [1901](https://github.com/dapr/components-contrib/pull/1901)
- **ADDED** Support for wildcard topics in in-memory PubSub [1966](https://github.com/dapr/components-contrib/pull/1966)
- **ADDED** Added pubsub.FeatureSubscribeWildcards capability [1887](https://github.com/dapr/components-contrib/pull/1887)
- **CHANGED** pubsub.redis: better ack for messages [1886](https://github.com/dapr/components-contrib/pull/1886)
- **ADDED** Add user agent to AWS requests [1890](https://github.com/dapr/components-contrib/pull/1890)
- **FIXED** Azure Service Bus Component: MessageID isn't guaranteed to be unique [1892](https://github.com/dapr/components-contrib/issues/1892) [1898](https://github.com/dapr/components-contrib/pull/1898)
- **CHANGED** modify error msg for rocketmq binding [1897](https://github.com/dapr/components-contrib/pull/1897)
- **FIXED** aws sqs component can not support  China region such as cn-northwest-1 [1907](https://github.com/dapr/components-contrib/issues/1907)
- **ADDED** Add auto-completion flag for Zeebe [1908](https://github.com/dapr/components-contrib/pull/1908)
- **ADDED** Allow metadata to flow through Service Bus queue [1911](https://github.com/dapr/components-contrib/pull/1911)
- **ADDED** Azure App Configuration: Implemented get all keys [1920](https://github.com/dapr/components-contrib/pull/1920)
- **ADDED** [Jetstream] Allow TLS Client Authentication [1923](https://github.com/dapr/components-contrib/issues/1923)
- **ADDED** [pubsub/jetstream]: allow tls client authentication [1924](https://github.com/dapr/components-contrib/pull/1924)
- **ADDED** pubsub.snssqs: Support regions in other AWS partitions [1925](https://github.com/dapr/components-contrib/pull/1925)
- **FIXED** Ensure rethinkdb complies with state.TransactionalStore [1930](https://github.com/dapr/components-contrib/pull/1930)
- **CHANGED** binding.eventhub: use same name schema for storage leases like on pubsub.eventhub [1940](https://github.com/dapr/components-contrib/pull/1940)
- **FIXED** Handle service bus exported errors [1942](https://github.com/dapr/components-contrib/pull/1942)
- **FIXED** bindings.cron: ensure it can resume correctly after context cancellation [1943](https://github.com/dapr/components-contrib/pull/1943)
- **FIXED** Distributed Lock components' code doesn't reflect renaming on UnlockResponse.Status [1950](https://github.com/dapr/components-contrib/issues/1950)
- **FIXED** Removing the use of the ioutil package and Fix CVE-2021-42576 [1954](https://github.com/dapr/components-contrib/pull/1954)
- **CHANGED** Update code to reflect renaming on UnlockResponse.Status [1958](https://github.com/dapr/components-contrib/pull/1958)
- **FIXED** Kafka: ConsumeClaim should not return err when retry recovery failed [1965](https://github.com/dapr/components-contrib/pull/1965) [2120](https://github.com/dapr/components-contrib/pull/2120)
- **ADDED** feature(secretstore): add tencent/ssm [1973](https://github.com/dapr/components-contrib/pull/1973)
- **FIXED** Fix CosmosDB state store handling of nulls  [1974](https://github.com/dapr/components-contrib/pull/1974)
- **CHANGED** Update to Go 1.19 [1975](https://github.com/dapr/components-contrib/pull/1975)
- **FIXED** Fixes to MySQL state store [1978](https://github.com/dapr/components-contrib/pull/1978)
- **ADDED** ETag support for the AWS Dynamo DB State Store [1981](https://github.com/dapr/components-contrib/issues/1981)
- **FIXED** Rethinkdb causes a panic error on daprd [1993](https://github.com/dapr/components-contrib/issues/1993)
- **FIXED** typos in Apache Cassandra logs [2010](https://github.com/dapr/components-contrib/pull/2010)
- **FIXED** Metadata propagation on Kafka event subscription [2016](https://github.com/dapr/components-contrib/issues/2016)
- **ADDED** read record header as metadata if available in kafka [2017](https://github.com/dapr/components-contrib/pull/2017)
- **ADDED** The component `bindings.azure.servicebusqueues` now supports a new field `disableEntityManagement`. When set to `true`, the queue will not be created automatically and sending/receiving messages will only require `Send`/`Listen` rights. [2018](https://github.com/dapr/components-contrib/issues/2018)  [2022](https://github.com/dapr/components-contrib/pull/2022)
- **CHANGED** Rethinkdb state store: Remove falsely-advertised transaction support [2020](https://github.com/dapr/components-contrib/pull/2020)
- **ADDED** AWS DynamoDB first write concurrency support [2021](https://github.com/dapr/components-contrib/pull/2021)
- **FIXED** Redis pubsub - bug in reclaimPendingMessage [2026](https://github.com/dapr/components-contrib/issues/2026)
- **ADDED** Support for a key prefix in AWS SSM Parameter Store secret store component [2043](https://github.com/dapr/components-contrib/pull/2043)
- **ADDED** Secret Stores advertise supported features. [2047](https://github.com/dapr/components-contrib/issues/2047)
- **FIXED** Kafka ConsumeClaim now returns when session context is done [2049](https://github.com/dapr/components-contrib/pull/2049)
- **FIXED** Duration based metadata serialization [2050](https://github.com/dapr/components-contrib/issues/2050)
- **ADDED** Support for Postgres as configuration store [2063](https://github.com/dapr/components-contrib/pull/2063)
- **FIXED** Addressed an issue in Azure App Config configuration store component preventing fetching of keys when using connection string authentication. [2064](https://github.com/dapr/components-contrib/pull/2064)
- **ADDED** Secret Stores now advertise supported Features. [2069](https://github.com/dapr/components-contrib/pull/2069)
- **FIXED** Addressed an issue in the Zeebe component parsing duration metadata [2070](https://github.com/dapr/components-contrib/pull/2070)
- **ADDED** Azure App Config configuration store `Subscribe` and `Unsubscribe` implementation [2088](https://github.com/dapr/components-contrib/pull/2088)
- **FIXED** Azure App Config store - GetAll return outdated values [2096](https://github.com/dapr/components-contrib/issues/2096)
- **CHANGED** Upgrade all Azure components using the Azure SDK for Go to their latest minor / patch SDK versions [2109](https://github.com/dapr/components-contrib/pull/2109)
- **FIXED** Sanitize metadata in requests to Azure Blob Storage #2112 [2112](https://github.com/dapr/components-contrib/pull/2112)
- **FIXED** mqtt component appends "-producer" making it incompatible with remote publisher [2114](https://github.com/dapr/components-contrib/issues/2114)
- **ADDED** Support for presigning in AWS S3 binding [2121](https://github.com/dapr/components-contrib/pull/2121)
- **ADDED** Adds time to CloudEvent automatically if not present [2123](https://github.com/dapr/components-contrib/pull/2123)
- **FIXED** Error handling in runtime and Redis config store [2124](https://github.com/dapr/components-contrib/pull/2124)
- **ADDED** New authentication options for RabbitMQ PubSub component [2129](https://github.com/dapr/components-contrib/pull/2129)
- **FIXED** OAuth2 middleware was not generating random identifiers [2139](https://github.com/dapr/components-contrib/pull/2139)
- **CHANGED** MQTT PubSub to handle consumerId and producerId separately [2183](https://github.com/dapr/components-contrib/issues/2183)

### Dashboard

- **FIXED** Wrong Dapr runtime version on About menu [201](https://github.com/dapr/dashboard/issues/201)
- **ADDED** Publish Dashboard image to GHCR as well [209](https://github.com/dapr/dashboard/pull/209)
- **ADDED** Support for querying of logs across all replica instances [216](https://github.com/dapr/dashboard/issues/216)
- **ADDED** Information on hosted actor types and count across replicas [218](https://github.com/dapr/dashboard/issues/218)

### .NET SDK

- **ADDED** Support passing trace headers [698](https://github.com/dapr/dotnet-sdk/issues/698)
- **ADDED** Support for TTL and time/interval formats in actor timers/reminders [788](https://github.com/dapr/dotnet-sdk/issues/788)
- **ADDED** Support for Sidecar Metadata APIs [883](https://github.com/dapr/dotnet-sdk/issues/883)
- **CHANGED** Change configuration API response to dictionary [884](https://github.com/dapr/dotnet-sdk/issues/884)
- **ADDED** Support the DeadLetter Topic of pubsub [897](https://github.com/dapr/dotnet-sdk/issues/897)
- **FIXED** Problem of determining whether there is a MetadataSeparator error [901](https://github.com/dapr/dotnet-sdk/issues/901)
- **ADDED** Actor exception details passed to caller [904](https://github.com/dapr/dotnet-sdk/issues/904)
- **FIXED** Actors Healthz are now always `AllowAnonymous`. [908](https://github.com/dapr/dotnet-sdk/issues/908)
- **ADDED** Support for sidecar shutdown API  [914](https://github.com/dapr/dotnet-sdk/issues/914)
- **FIXED** SDK code doesn't reflect renaming on UnlockResponse.Status [921](https://github.com/dapr/dotnet-sdk/issues/921)

### Go SDK

- **FIXED** panic: error creating default client: error creating connection to '127.0.0.1:50001': context deadline exceeded: context deadline exceeded [259](https://github.com/dapr/go-sdk/issues/259)
- **FIXED** fix: client default timeout [310](https://github.com/dapr/go-sdk/pull/310)
- **FIXED** feature(apphealth&configuration): add app health check & adapt new configuration API [323](https://github.com/dapr/go-sdk/issues/323)
- **ADDED** Add SaveStateWithETag() convenience function [321](https://github.com/dapr/go-sdk/pull/321)

### Java SDK

- **ADDED** Configuration building block HTTP APIs and gRPC unsubscribe API [698](https://github.com/dapr/java-sdk/issues/698)
- **FIXED** Metadata ignored on Htttp Service invocation [744](https://github.com/dapr/java-sdk/issues/744)
- **CHANGED** Change configuration API response to dictionary [746](https://github.com/dapr/java-sdk/issues/746)
- **CHANGED** CloudEvent class to be non-final and inherited at application's code [773](https://github.com/dapr/java-sdk/issues/773)

### Python SDK

- **ADDED** Support for Sidecar Metadata APIs [410](https://github.com/dapr/python-sdk/issues/410)
- **CHANGED** Configuration API response to dictionary [457](https://github.com/dapr/python-sdk/pull/457)
- **ADDED** Support for Distributed Lock API [431](https://github.com/dapr/python-sdk/pull/431)
- **ADDED** Example for using pubsub with FastApi [444](https://github.com/dapr/python-sdk/pull/444)
- **ADDED** `dapr.ext.grpc` support for specifying max pubsub message length (`>4MB`) [451](https://github.com/dapr/python-sdk/issues/451)
- **FIXED** `dapr.ext.grpc` removed optional `app_port` parameter from being required in run method [454](https://github.com/dapr/python-sdk/issues/454)
- **CHANGED** Increased minimum `protobuf` version from `3.20.1` to `>=4.21.0` [457](https://github.com/dapr/python-sdk/pull/457)
- **ADDED** Support for timeouts in service invocation calls from Dapr client [473](https://github.com/dapr/python-sdk/pull/473)
- **ADDED** Add PEP 561 `py.typed` markers to all packages to allow consumers to check dapr types with e.g. mypy [475](https://github.com/dapr/python-sdk/pull/475)

### JavaScript SDK

- **ADDED** feat(lock): Distributed lock API support [306](https://github.com/dapr/js-sdk/pull/306)
- **FIXED** fix(types): Module 'HTTP' has no default export error [308](https://github.com/dapr/js-sdk/pull/308)
- **FIXED** docs(index): Fix index content and images due to a bad merge [311](https://github.com/dapr/js-sdk/pull/311)
- **ADDED** chore(deprecation): Warning message to dapr-client builds [313](https://github.com/dapr/js-sdk/pull/313)
- **ADDED** feat(state): Metadata field to the state save operation [323](https://github.com/dapr/js-sdk/pull/323)
- **FIXED** fix(client): Sidecar not starting when calling getClient [324](https://github.com/dapr/js-sdk/pull/324)
- **ADDED** tests(e2e/grpc): Configuration API test for subscribe all keys [327](https://github.com/dapr/js-sdk/pull/327)
- **ADDED** feat(pubsub): Allow passing metadata to publish and subscribe API [329](https://github.com/dapr/js-sdk/pull/329)
- **CHANGED** chore(github): Migrate from master branch to main branch [331](https://github.com/dapr/js-sdk/pull/331)
- **FIXED** fix(pubsub): Send correct HTTP response in subscribe event handler [334](https://github.com/dapr/js-sdk/pull/334)
- **FIXED** fix(lock): Renaming distributed lock API UnlockResponse.Status [337](https://github.com/dapr/js-sdk/pull/337)
- **FIXED** fix(client): Reusing same HTTP client instance [340](https://github.com/dapr/js-sdk/pull/340)
- **ADDED** feat(pubsub): Implement pubsub dead letter & single/multi routing [342](https://github.com/dapr/js-sdk/pull/342)
- **ADDED** feat(actors): Allow actors to be configurable [346](https://github.com/dapr/js-sdk/pull/346)
- **ADDED** feat(metadata): Support capabilities field in metadata API [347](https://github.com/dapr/js-sdk/pull/347)
- **ADDED** docs(dev): Reference documentation for release process [353](https://github.com/dapr/js-sdk/pull/353)
- **FIXED** fix(logger): Propagate logger to sidecar awaiting method [358](https://github.com/dapr/js-sdk/pull/358)
- **FIXED** fix(types): Mark exported types as dependencies in package.json [359](https://github.com/dapr/js-sdk/pull/359)
- **ADDED** docs(lock): Distributed locks documentation [362](https://github.com/dapr/js-sdk/pull/362)
- **ADDED** feat(client): API token authentication support using DAPR_API_TOKEN [364](https://github.com/dapr/js-sdk/pull/364)
- **ADDED** feat(actors): Ability to specify type in ActorStateManager [372](https://github.com/dapr/js-sdk/pull/372)
- **ADDED** chore(ci): Add prettifier, prettify codebase, and add check to build CI [384](https://github.com/dapr/js-sdk/pull/384)
- **ADDED** feat(pubsub): Allow headers to be passed to pubsub [389](https://github.com/dapr/js-sdk/pull/389)

### Quickstarts

- **FIXED** Why Pub-Sub url does not redirect to an external page [711](https://github.com/dapr/quickstarts/issues/711)
- **FIXED** Some quickstarts demos incompatible with Java 11 [719](https://github.com/dapr/quickstarts/issues/719)
- **FIXED** Python pubsub examples failing [724](https://github.com/dapr/quickstarts/issues/724)
- **FIXED** Distributed calculator example is not working  [726](https://github.com/dapr/quickstarts/issues/726)

## Upgrading to Dapr 1.9.0

To upgrade to this release of Dapr, follow the steps here to ensure a smooth upgrade. You know, the one where you don't get red errors on the terminal.. we all hate that, right?

### Local Machine / Self-hosted

Uninstall Dapr using the CLI you currently have installed. Note that this will remove the default $HOME/.dapr directory, binaries and all containers dapr_redis, dapr_placement and dapr_zipkin. Linux users need to run sudo if docker command needs sudo:

```bash
dapr uninstall --all
```

For RC releases like this, download the latest and greatest release from [here](https://github.com/dapr/cli/releases) and put the `dapr` binary in your PATH.

Once you have installed the CLI, run:

```bash
dapr init --runtime-version=1.9.0
```

Wait for the update to finish,  ensure you are using the latest version of Dapr(1.9.0) with:

```bash
$ dapr --version

CLI version: 1.9.0
Runtime version: 1.9.0
```

### Kubernetes

#### Upgrading from previous version

You can perform zero-downtime upgrades using both Helm 3 and the Dapr CLI.

##### Upgrade using the CLI

Download the latest RC release from [here](https://github.com/dapr/cli/releases) and put the `dapr` binary in your PATH.

To upgrade Dapr, run:

```
dapr upgrade --runtime-version 1.9.0 -k
```

To upgrade with high availability mode:

```
dapr upgrade --runtime-version 1.9.0 --enable-ha=true -k
```

Wait until the operation is finished and check your status with `dapr status -k`.

All done!

*Note: Make sure your deployments are restarted to pick the latest version of the Dapr sidecar*

##### Upgrade using Helm

To upgrade Dapr using Helm, run:

```
helm repo add dapr https://dapr.github.io/helm-charts/
helm repo update

helm upgrade dapr dapr/dapr --version 1.9.0 --namespace=dapr-system --wait
```

Wait until the operation is finished and check your status with `dapr status -k`.

All done!

*Note: Make sure your deployments are restarted to pick the latest version of the Dapr sidecar*

#### Starting a fresh install on a cluster

Please see [how to deploy Dapr on a Kubernetes cluster](https://docs.dapr.io/operations/hosting/kubernetes/kubernetes-deploy/) for a complete guide to installing Dapr on Kubernetes

You can use Helm 3 to install Dapr:
```
helm repo add dapr https://dapr.github.io/helm-charts/
helm repo update

kubectl create namespace dapr-system

helm install dapr dapr/dapr --version 1.9.0 --namespace dapr-system --wait
```

Alternatively, you can use the latest version of CLI:

```
dapr init --runtime-version=1.9.0 -k
```

##### Post installation

Verify the control plane pods are running and are healthy:

```
$ dapr status -k
  NAME                   NAMESPACE    HEALTHY  STATUS   REPLICAS  VERSION  AGE  CREATED
  dapr-dashboard         dapr-system  True     Running  1         0.11.0  15s  2022-10-04 13:07.39
  dapr-sidecar-injector  dapr-system  True     Running  1         1.9.0   15s  2022-10-04 13:07.39
  dapr-sentry            dapr-system  True     Running  1         1.9.0   15s  2022-10-04 13:07.39
  dapr-operator          dapr-system  True     Running  1         1.9.0   15s  2022-10-04 13:07.39
  dapr-placement         dapr-system  True     Running  1         1.9.0   15s  2022-10-04 13:07.39
```

After Dapr 1.9.0 has been installed, perform a rolling restart for your deployments to pick up the new version of the sidecar.
This can be done with:

```
kubectl rollout restart deploy/<deployment-name>
```

## Breaking Changes

### Dapr Runtime
- **RENAMED** Distributed Lock API UnlockResponse.Status [4988](https://github.com/dapr/dapr/issues/4988)
- **REMOVED** `application/json` as default content type for service invocation [5165](https://github.com/dapr/dapr/issues/5165)
- **CHANGED** Configuration API response to dictionary [4556](https://github.com/dapr/dapr/issues/4556)
- **CHANGED** Service Invocation NoDefaultContentType flag has been removed and it's now enabled by default [5243](https://github.com/dapr/dapr/issues/5243)
### Components
- **FIXED** Distributed Lock components' code doesn't reflect renaming on UnlockResponse.Status [1950](https://github.com/dapr/components-contrib/issues/1950)
### .NET SDK
- **FIXED** SDK code doesn't reflect renaming on UnlockResponse.Status [921](https://github.com/dapr/dotnet-sdk/issues/921)
- **CHANGED** Configuration API response to dictionary [884](https://github.com/dapr/dotnet-sdk/issues/884)

### Java SDK
- **ADDED** Unsubscribe API to PreviewClient [698](https://github.com/dapr/java-sdk/issues/698)
- **CHANGED** Configuration API response to dictionary [746](https://github.com/dapr/java-sdk/issues/746)

### Python SDK
- **CHANGED** Configuration API response to dictionary [411](https://github.com/dapr/python-sdk/issues/411)

### Go SDK
- **CHANGED** Configuration API response to dictionary [291](https://github.com/dapr/go-sdk/issues/291)
